# -*- coding: utf-8 -*-
import requests
import httplib
from urlparse import urlparse
import os
from bs4 import BeautifulSoup


class common(object):

    @staticmethod
    def getVendorPath(vendor):
        ruta = os.path.dirname(os.path.abspath(__file__))
        ruta = ruta.split('/')
        del ruta[-1]
        ruta.append('vendor')
        ruta.append(vendor)
        ruta = '/'.join(ruta)
        return ruta+'/'

    @staticmethod
    def checkUrl(url):
        p = urlparse(url)
        conn = httplib.HTTPConnection(p.netloc)
        conn.request('HEAD', p.path)
        resp = conn.getresponse()
        return resp.status < 400

    @staticmethod
    def search_params(url):
        params = urlparse.urlparse(url)
        return params.query

    @staticmethod
    def get_content(url):
        page = requests.get(url)
        if page.status_code == 200:
            content = page.content
            return content
        else:
            return False

    @staticmethod
    def clean_and_list(cadena):
        cadena = [param.strip() for param in cadena.split(',')]
        return cadena

    @staticmethod
    def post_to_url(cadena):
        cadena = '=&'.join(common.clean_and_list(cadena))
        return cadena

    @staticmethod
    def getFormInfo(content, url, ids=None, clases=None, posts=None):

        soup = BeautifulSoup(content)
        result = {}

        # TODO: Posar-ho en una funció per no repetir codi

        if ids:
            inputv = soup.findAll("input", {"id": ids})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if clases:
            inputv = soup.findAll("input", {"class": clases})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if posts:
            inputv = soup.findAll("input", {"name": posts})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if not ids and not clases and not posts:
            inputv = soup.findAll("input")
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        allp = {}
        inputv = soup.findAll("input")
        for i in inputv:
            if i['type'] not in ['submit', 'button', 'password']:
                name = i['name']
                val = i['value']
                p = i.findParent("form")
                if p:
                    action = url if p['action'] == '' else p['action']
                else:
                    action = url
                if action not in allp:
                    allp[action] = {}
                allp[action][name] = val

        return result, allp