# -*- coding: utf-8 -*-
import requests
from bs4 import BeautifulSoup
from common import common
import urlparse


class xml_injection():

    def __init__(self):
        return None

    @staticmethod
    def scan(url, params=None, ids=None, clases=None, posts=None):

        res = []
        sxss = {}
        r = requests.get(url)
        url_parse = urlparse.urlparse(url)
        path = url_parse.path.split('/')
        del path[-1]
        path = '/'.join(path)
        base_url = url_parse.scheme+'://'+url_parse.netloc+path

        ids = common.clean_and_list(ids) if ids else None
        clases = common.clean_and_list(clases) if clases else None
        posts = common.clean_and_list(posts) if posts else None

        forms, allp = xml_injection.getFormInfo(r.content, base_url, url, ids, clases, posts)

        all_inputs = {}

        # Relleno con tod
        for action in allp:
            for inp, val in allp[action].items():
                all_inputs[inp] = val

        for action in forms:
            init_val = {}
            for i, v in forms[action].items():
                payload = '<'
                post_val = all_inputs
                init_val[i] = v
                post_val[i] = payload
                # print action
                # print post_val
                requests.post(action, data=post_val)
                req = requests.get(url).content
                # print req
                if 'Warning' in req or 'Error' in req:
                    param_name = i+' (POST)'
                    if param_name not in sxss:
                        sxss[param_name] = []
                    sxss[param_name].append({
                        'type': 'XML Injection',
                        'title': 'Vulnerable a XML Injection',
                        'payload': payload
                    })
            res.append(sxss)
        print res
        if not res[0]:
            res = False
        return res

    @staticmethod
    def getFormInfo(content, base_url, url, ids=None, clases=None, posts=None):

        soup = BeautifulSoup(content)
        result = {}

        # TODO: Posar-ho en una funció per no repetir codi

        if ids:
            inputv = soup.findAll("input", {"id": ids})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = ''  # i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else base_url+'/'+p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if clases:
            inputv = soup.findAll("input", {"class": clases})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = ''  # i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else base_url+'/'+p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if posts:
            inputv = soup.findAll("input", {"name": posts})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = ''  # i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else base_url+'/'+p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if not ids and not clases and not posts:
            inputv = soup.findAll("input")
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = ''  # i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else base_url+'/'+p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        allp = {}
        inputv = soup.findAll("input")
        for i in inputv:
            if i['type'] not in ['submit', 'button', 'password']:
                name = i['name']
                val = ''  # i['value']
                p = i.findParent("form")
                if p:
                    action = url if p['action'] == '' else base_url+'/'+p['action']
                else:
                    action = url
                if action not in allp:
                    allp[action] = {}
                allp[action][name] = val

        return result, allp
