# -*- coding: utf-8 -*-
import requests
import urlparse
import time
from bs4 import BeautifulSoup
from common import common


class xss():

    def __init__(self):
        return None

    @staticmethod
    def scan(url, params=None, ids=None, clases=None, posts=None):

        res = []

        # REFLECTED XSS --------------------------------

        # Extreiem els parametres
        url_parse = urlparse.urlparse(url)
        url_params = urlparse.parse_qs(url_parse.query)

        if params:
            params = common.clean_and_list(params)
            url_copy = url_params.copy()
            for param in url_copy:
                if param not in params:
                    del url_params[param]

        for param, value in url_params.items():
            payload = '<script>alert("'+str(time.time())+'");</script>'

            old_params = ''
            for param2, value2 in url_params.items():
                if param != param2:
                    old_params += '&'+param2+'='+value2[0]

            new_url = url_parse.scheme+'://'+url_parse.netloc+url_parse.path
            new_url += '?'+param+'='+payload+old_params
            temp = {}

            r = requests.get(new_url)
            if payload in r.content:
                param_key = param+' (GET)'
                if param not in temp:
                    temp[param_key] = []
                temp[param_key].append({
                    'type': 'Reflected XSS',
                    'title': 'Vulnerabilitat XSS no persistent',
                    'payload': payload
                })
                res.append(temp)

        # STORED XSS --------------------------------
        sxss = {}
        r = requests.get(url)

        ids = common.clean_and_list(ids) if ids else None
        clases = common.clean_and_list(clases) if clases else None
        posts = common.clean_and_list(posts) if posts else None

        forms, allp = xss.getFormInfo(r.content, url, ids, clases, posts)

        all_inputs = {}

        # Relleno con tod
        for action in allp:
            for inp, val in allp[action].items():
                all_inputs[inp] = val

        for action in forms:
            init_val = {}
            for i, v in forms[action].items():
                payload = '<script>alert("'+str(time.time())+'");</script>'
                post_val = all_inputs
                init_val[i] = v
                post_val[i] = payload
                requests.post(action, data=post_val)
                req = requests.get(url).content

                if payload in req:
                    param_name = i+' (POST)'
                    if param_name not in sxss:
                        sxss[param_name] = []
                    sxss[param_name].append({
                        'type': 'Stored XSS',
                        'title': 'Vulnerabilitat XSS en el formulari',
                        'payload': payload
                    })
            res.append(sxss)

            # Restablim els valors inicials:
            requests.post(action, data=init_val)
        if not res[0]:
            return False
        else:
            return res

    @staticmethod
    def getFormInfo(content, url, ids=None, clases=None, posts=None):

        soup = BeautifulSoup(content)
        result = {}

        # TODO: Posar-ho en una funció per no repetir codi

        if ids:
            inputv = soup.findAll("input", {"id": ids})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if clases:
            inputv = soup.findAll("input", {"class": clases})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if posts:
            inputv = soup.findAll("input", {"name": posts})
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        if not ids and not clases and not posts:
            inputv = soup.findAll("input")
            for i in inputv:
                if i['type'] not in ['submit', 'button', 'password']:
                    name = i['name']
                    val = i['value']
                    p = i.findParent("form")
                    if p:
                        action = url if p['action'] == '' else p['action']
                    else:
                        action = url
                    if action not in result:
                        result[action] = {}
                    result[action][name] = val

        allp = {}
        inputv = soup.findAll("input")
        for i in inputv:
            if i['type'] not in ['submit', 'button', 'password']:
                name = i['name']
                val = i['value']
                p = i.findParent("form")
                if p:
                    action = url if p['action'] == '' else p['action']
                else:
                    action = url
                if action not in allp:
                    allp[action] = {}
                allp[action][name] = val

        return result, allp
