/*!
 * scanner.js versió 0.1
 * Projecte final de màster
 * Eric Bujeque Escorriola
 */

// using jQuery
function getCookie(name) {
    var cookieValue = null;
    if (document.cookie && document.cookie != '') {
        var cookies = document.cookie.split(';');
        for (var i = 0; i < cookies.length; i++) {
            var cookie = jQuery.trim(cookies[i]);
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) == (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}

$(document).ready(function() {

    $("#start_scan").click(function(){

        var error = 0;

        // Agafo els valors del camps
        var url = $("#url").val();
        var ids = $("#ids").val();
        var classes = $("#classes").val();
        var params = $("#params").val();
        var posts = $("#posts").val();

        // Valido el camp de la url
        if(!url.trim()){
            $("#urldiv").addClass('has-error');
            error = 1;
        }
        else{
            $("#urldiv").removeClass('has-error');
        }

        // Verifico si hi ha algun test seleccionat
        var check = $(".test:checked").length;
        if (check == 0){
            $(".checkbox").addClass('has-error');
            error = 1;
        }
        else{
            $(".checkbox").removeClass('has-error');
        }

        if(error == 1){
            return false;
        }

        // Per enviar un formulari amb Django s'ha de fer el següent
        var csrftoken = getCookie('csrftoken');

        function csrfSafeMethod(method) {
            // these HTTP methods do not require CSRF protection
            return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
        }

        $.ajaxSetup({
            beforeSend: function(xhr, settings) {
                if (!csrfSafeMethod(settings.type) && !this.crossDomain) {
                    xhr.setRequestHeader("X-CSRFToken", csrftoken);
                }
            }
        });

        //$('#resultats').show();
        //$('#tests').hide();
        //$('#formulari').hide();
        //$('#jumbo').hide();

        // Cridem als test

        // SQL INJECTION
        //alert($('#test2').prop('checked'));
        //if($('#test2').prop('checked')) {
        //    $.post("scan/", {'url': url}, function (data) {
        //        if (data) {
        //            var taula = '<table class="table table-hover"><thead><tr><th>Parametre</th><th>Vulnerabilitat</th><th>Descripció</th><th>Payload</th></tr></thead><tbody>';
        //        }
        //        console.log(taula);
        //        $.each(data, function (params, paramsval) {
        //            $.each(paramsval, function (param, vul) {
        //                $.each(vul, function (fields, field) {
        //                    //alert('key: '+key3+' val: '+val3);
        //                    taula += '<tr><td>' + param + '</td>' + '<td>' + field['type'] + '</td>' + '<td>' + field['title'] + '</td>' + '<td>' + field['payload'] + '</td></tr>';
        //                    console.log(taula);
        //                });
        //            });
        //        });
        //        taula += '</tbody></table>';
        //        $('#resultat_content').html(taula);
        //    });
        //}

    });

    $("#select-all").click(function(){

        // Seleccionem tots els tests
        $(".test").prop('checked', true);
        $(".checkbox").removeClass('has-error');
    });

    $("#unselect-all").click(function(){

        // Deseleccionem tots els tests
        $(".test").prop('checked', false);
    });


    $('[data-toggle="popover"]').popover({
        placement : 'left'
    });

    $('[data-toggle="popover2"]').popover({
        placement : 'right'
    });

    $(".clickable").click(function() {
        window.document.location = $(this).data("href");
    });
});
